(function($, Drupal) {
	'use strict';

	var countdownSelector = $('[data-js-module="cbs-countdown-scheduler"]');
	var futureDate = drupalSettings.countdown_scheduler.timerdate;

	Drupal.behaviors.cbsCountDown = {
		attach: function(context, settings) {

			var _this = this;
			$(countdownSelector, context).each(function() {
				_this.init($(this));
			});
		},

		init: function(element) {
			var _this = this;
			/* Call the countdown timer function in set intervals */
			if (futureDate != null) {
				setInterval(function() {
					_this.timerCountDown($(this));
				}, 1000);
			}
		},
		/* Function to calculate date/time difference */
		timerCountDown: function() {
			var endTime = new Date(futureDate);
			endTime = (Date.parse(endTime) / 1000);
			var now = new Date();
			now = (Date.parse(now) / 1000);
			var timeLeft = endTime - now;
			var days = Math.floor(timeLeft / 86400);
			var hours = Math.floor((timeLeft - (days * 86400)) / 3600);
			var minutes = Math.floor((timeLeft - (days * 86400) - (hours * 3600)) / 60);
			var seconds = Math.floor((timeLeft - (days * 86400) - (hours * 3600) - (minutes * 60)));

			var daysCheck = days;
			if (days < 10) {
				days = '0' + days;
			}
			if (hours < 10) {
				hours = '0' + hours;
			}
			if (minutes < 10) {
				minutes = '0' + minutes;
			}
			if (seconds < 10) {
				seconds = '0' + seconds;
			}
			if (daysCheck > -1) {
				/* Replace countdown timer html section */
				$('#countdown-days p.days').html(days);
				$('#countdown-hours p.hours').html(hours);
				$('#countdown-minutes p.mins').html(minutes);
				$('#countdown-seconds p.secs').html(seconds);
			} else {
				/* Replace countdown section with closure msg */
				$('#countdown-timer').hide();
				$('.timer-desc').hide();
				$('.timer-closure').fadeIn();
			}

		},
	};

})(jQuery, Drupal);
